package com.jetbyte.cache2;

public class CacheKey implements Comparable
{
   public CacheKey()
   {
      setKey("");
   }

   public CacheKey(String key)
   {
      keyValue = key;
      hashCode = keyValue.hashCode();
   }

   public void setKey(String key)
   {
      keyValue = key;
      hashCode = keyValue.hashCode();
   }

   public String toString()
   {
      return keyValue;
   }

   public int hashCode()
   {
      System.out.println("hashCode() - \"" + keyValue + "\" - " + hashCode);

      return hashCode;
   }

   public boolean equals(Object obj)
   {
      System.out.println("equals() - \"" + keyValue + "\" - " + hashCode);

      if (this == obj)
      {
         return true;
      }
      else if (obj == null || getClass() != obj.getClass())
      {
         return false;
      }

      CacheKey rhs = (CacheKey) obj;

      return keyValue.equals(rhs.keyValue);
   }

   public int compareTo(Object obj)
   {
      System.out.println("compareTo() - \"" + keyValue + "\" - " + hashCode);

      if (this.equals(obj))
      {
         return 0;
      }

      CacheKey rhs = (CacheKey) obj;

      return keyValue.compareTo(rhs.keyValue);
   }

   private String keyValue;

   private int hashCode;
}
